* add computed lags
gen emplag1 = 2*denom - emp if ageg > 1
replace emplag1 = 0 if ageg == 1
gen firmslag1 = firms + firmdeath_firms if ageg > 1
replace firmslag1 = 0 if ageg == 1

* adjusted job creation for age 0
ren job_creation job_creation2
replace job_creation2 = emp if ageg == 1
ren net_job_creation net_job_creation2
replace net_job_creation2 = emp if ageg == 1
ren job_creation_births job_creation_births2
replace job_creation_births2 = emp if ageg == 1

* add totals by year 
egen long jctot = sum(job_creation2), by(year2 sicg)
egen long jdtot = sum(job_destruction), by(year2 sicg)
egen long njctot = sum(net_job_creation2), by(year2 sicg)
egen long denomtot = sum(denom), by(year2 sicg)
egen long emptot = sum(emp), by(year2 sicg)
egen long firmstot = sum(firms), by(year2 sicg)
egen long emplag1tot = sum(emplag1), by(year2 sicg)
egen long firmslag1tot = sum(firmslag1), by(year2 sicg)

* add shares
gen empshr = emp/emptot 
gen firmsshr = firms/firmstot
gen emplag1shr = emplag1/emplag1tot
gen firmslag1shr = firmslag1/firmslag1tot

* adjustment for startups
bys ageg sicg (year2): replace emplag1shr = empshr[_n-1] if ageg == 1 /* to help with aggregation */
replace firmslag1shr = 1 if ageg == 1 

* job creation/destruction measures
gen jcr = job_creation2/emplag1 if ageg > 1
gen jcr_b = job_creation_births2/emplag1 if ageg > 1
gen jcr_c = job_creation_continuers/emplag1 if ageg > 1
gen jcr_s = job_creation2/(emplag1 - firmdeath_emp) if ageg > 1 /* job creation from survivors */
gen jdr = job_destruction/emplag1 if ageg > 1
gen jdr_c = job_destruction_continuers/emplag1 if ageg > 1
gen jdr_s = (job_destruction - firmdeath_emp)/(emplag1 - firmdeath_emp) if ageg > 1 /* job destruction from survivors */
gen jdr_ed = job_destruction_deaths/emplag1 if ageg > 1 /* job destruction from establishment exit */
gen jdr_fd = firmdeath_emp/emplag1 if ageg > 1 /* job destruction from firm exit */
gen njcr = jcr - jdr

* adjustment startups
bys ageg sicg (year2): replace jcr = emp[_n]/emp[_n-1] if ageg == 1 /* gross startup growth rate */
replace jdr = 0 if ageg == 1
replace njcr = jcr if ageg == 1

* aggregate across age groups job creation/destruction
egen jcrtot = sum(jcr*emplag1shr), by (year2 sicg)
egen jdrtot = sum(jdr*emplag1shr), by (year2 sicg)
egen njcrtot = sum((jcr-jdr)*emplag1shr), by(year2 sicg)

* firm survival measures
gen firmsurv = firms/firmslag1 if ageg > 1
gen fcr = -firmdeath_firms/firmslag1tot if ageg > 1
replace fcr = firms/firmslag1tot if ageg == 1

* average firm size measures 
* firm characteristics by age and year
gen avgsize = emp/firms
gen avgsizelag1 = emplag1/firmslag1 if ageg > 1
gen avgsizegrowth = avgsize/avgsizelag1 - 1 if ageg > 1
